package org.diligentproject.searchservice.clients;

import java.io.BufferedWriter;
import java.io.FileWriter;

import org.apache.axis.message.addressing.Address;
import org.apache.axis.message.addressing.EndpointReferenceType;
import org.diligentproject.searchservice.queryextsourceoperatorjdbc.stubs.*;
import org.diligentproject.searchservice.queryextsourceoperatorjdbc.stubs.service.*;

public class JdbcClient {
	
	static String serviceURI=null;
	static String expression=null;
	static String outFile=null;
	
	public static void main(String[] args) {
		try{
			if(!parseInput(args)){
				System.out.println("-location <host>:<port> -expression <expression> -output <filename>");
				return;
			}
			
			EndpointReferenceType endpoint = new EndpointReferenceType();
			endpoint.setAddress(new Address(serviceEndPoint()));
			
			QueryExtSourceOperatorJDBCServiceAddressingLocator locator= new QueryExtSourceOperatorJDBCServiceAddressingLocator();
			QueryExtSourceOperatorJDBCPortType pt= locator.getQueryExtSourceOperatorJDBCPortTypePort(endpoint);
			SearchExternalSource params=new SearchExternalSource();
			params.setQueryString(expression);
			writeFile(pt.searchExternalSource(params),outFile);
		}catch (Exception e){
			e.printStackTrace();
		}
	}
	
	private static boolean parseInput(String []args){
		try{
			for (int i=0;i<args.length;i+=1){
				if (args[i].equalsIgnoreCase("-location")){
					if(serviceURI!=null) return false;
					i+=1;
					serviceURI=args[i];
				}
				if (args[i].equalsIgnoreCase("-output")){
					if(outFile!=null) return false;
					i+=1;
					outFile=args[i];
				}
				if (args[i].equalsIgnoreCase("-expression")){
					if(expression!=null) return false;
					i+=1;
					expression=args[i];
				}
			}
			if (serviceURI==null || outFile==null||expression==null) return false;
			return true;
		}catch(Exception e){
			e.printStackTrace();
			return false;
		}
	}
	
	private static void writeFile(String text,String filename) throws Exception{
		FileWriter fw=new FileWriter(filename);
		BufferedWriter bw=new BufferedWriter(fw);
		bw.write(text);
		bw.close();
		fw.close();
	}

	private static String serviceEndPoint(){
		return "http://"+serviceURI+"/wsrf/services/diligentproject/searchservice/SearchMasterService";
	}
}
