package org.diligentproject.searchservice.clients;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;

import org.apache.axis.message.addressing.Address;
import org.apache.axis.message.addressing.EndpointReferenceType;
import org.diligentproject.searchservice.joininneroperator.stubs.*;
import org.diligentproject.searchservice.joininneroperator.stubs.service.*;

public class JoinInnerClient {
	
	static String serviceURI=null;
	static String key=null;
	static String lepr=null;
	static String lfepr=null;
	static String repr=null;
	static String rfepr=null;
	static String outFile=null;
	
	public static void main(String[] args) {
		try{
			if(!parseInput(args)){
				System.out.println("-location <host>:<port> -key <key> -lepr <epr> -repr <epr> -output <filename>");
				return;
			}
			
			EndpointReferenceType endpoint = new EndpointReferenceType();
			endpoint.setAddress(new Address(serviceEndPoint()));
			
			JoinInnerOperatorServiceAddressingLocator locator= new JoinInnerOperatorServiceAddressingLocator();
			JoinInnerOperatorPortType pt= locator.getJoinInnerOperatorPortTypePort(endpoint);
			JoinInnerUnsorted params=new JoinInnerUnsorted();
			params.setKey(key);
			params.setLeftInput(lepr);
			params.setRightInput(repr);
			writeFile(pt.joinInnerUnsorted(params),outFile);
		}catch (Exception e){
			e.printStackTrace();
		}
	}
	
	private static boolean parseInput(String []args){
		try{
			for (int i=0;i<args.length;i+=1){
				if (args[i].equalsIgnoreCase("-location")){
					if(serviceURI!=null) return false;
					i+=1;
					serviceURI=args[i];
				}
				if (args[i].equalsIgnoreCase("-key")){
					if(key!=null) return false;
					i+=1;
					key=args[i];
				}
				if (args[i].equalsIgnoreCase("-output")){
					if(outFile!=null) return false;
					i+=1;
					outFile=args[i];
				}
				if (args[i].equalsIgnoreCase("-lepr")){
					if(lfepr!=null) return false;
					i+=1;
					lfepr=args[i];
					lepr=readFile(lfepr);
				}
				if (args[i].equalsIgnoreCase("-repr")){
					if(rfepr!=null) return false;
					i+=1;
					rfepr=args[i];
					repr=readFile(rfepr);
				}
			}
			if (serviceURI==null || key==null|| outFile==null||lepr==null||repr==null) return false;
			return true;
		}catch(Exception e){
			e.printStackTrace();
			return false;
		}
	}
	
	private static String readFile(String filename) throws Exception{
		FileReader fr=new FileReader(filename);
		BufferedReader br=new BufferedReader(fr);
		StringBuilder buf=new StringBuilder();
		String line =br.readLine();
		while (line!=null){
			buf.append(line);
			line=br.readLine();
		}
		br.close();
		fr.close();
		return buf.toString();
	}
	
	private static void writeFile(String text,String filename) throws Exception{
		FileWriter fw=new FileWriter(filename);
		BufferedWriter bw=new BufferedWriter(fw);
		bw.write(text);
		bw.close();
		fw.close();
	}

	private static String serviceEndPoint(){
		return "http://"+serviceURI+"/wsrf/services/diligentproject/searchservice/SearchMasterService";
	}
}
